package org.softme.webpm.jwiki;
import org.w3c.dom.*;
import org.softme.webpm.utility.XMLUtility;
import java.util.HashMap;
import org.softme.webpm.pub.Debug;
import java.util.ArrayList;
import org.softme.webpm.pub.WebPmConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WebPMTagProcessor implements TagProcessor{

    public WebPMTagProcessor() {
    }
    //private final String TAG_FILE="/usr/tomcat/tomcat/webapps/webpm/tag.xml";

    private ArrayList tags=null;
    public void setTags(ArrayList pTags){
        this.tags =pTags;
    }
    public String process(String pStr){
       for(int i=0;i<tags.size() ;i++){
           TagInfo oneTag=(TagInfo)tags.get(i);
           pStr=REReplace.replace(oneTag.ubbcode ,oneTag.mapcode,pStr) ;
       }
       return pStr;

    }

    protected ArrayList loadTag(String xmlTag){
        ArrayList tags=new ArrayList();
        Document doc=XMLUtility.xml2Document(WebPmConfig.getProperty("Path.tagfile")) ;
        NodeList wikiNodeList=doc.getElementsByTagName(xmlTag) ;
        Element wikiElement=(Element)wikiNodeList.item(0) ;
        NodeList tagMaps=wikiElement.getElementsByTagName("map") ;
        TagInfo oneTag=null;
        for(int i=0;i<tagMaps.getLength() ;i++){
            oneTag=new TagInfo();
            NamedNodeMap attrs=(tagMaps.item(i)).getAttributes() ;
            oneTag.ubbcode =attrs.getNamedItem("ubb-code").getNodeValue() ;
            oneTag.mapcode =attrs.getNamedItem("map-to").getNodeValue()  ;
            tags.add(oneTag) ;
            Debug.println(oneTag.ubbcode ) ;
        }
        return tags;
    }

    public class TagInfo {
        public String ubbcode=null;
        public String mapcode=null;
        public TagInfo() {
        }
    }

}