package org.softme.webpm.pub;
import junit.framework.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WebPmConfigTest extends TestCase{

  public WebPmConfigTest(String name) {
      super(name);
  }
  public static void main(String[] args) {

      junit.textui.TestRunner.run(WebPmConfigTest.class) ;

  }
  public void testConfigParam(){

      final String DBUser="webpm";
      final String DBPass="webpm";
      final String DBURL="jdbc:mysql://192.168.1.228:3306/webpm";
      final String DBDriver="org.gjt.mm.mysql.Driver";
      final String ArticleFactoryImp="org.softme.webpm.jwiki.ArticleFactoryImp";
      final String TagProcessorFactoryImp="org.softme.webpm.jwiki.TagProcessorFactoryImp";
      final String db2MenoryCode="";
      final String db2MenoryGetBytesCode="";
      final String menory2DBCode="GB2312";
      final String menory2DBGetBytesCode="ISO-8859-1";
      final String urlParam2StringCode="ISO-8859-1";
      final String urlParam2StringGetBytesCode="GB2312";
      final String string2URLParamCode="";
      final String string2URLParamGetBytesCode="";

      assertEquals(db2MenoryCode,WebPmConfig.getProperty("Encoder.DB2MenoryCode"));
      assertEquals(db2MenoryGetBytesCode,WebPmConfig.getProperty("Encoder.DB2MenoryGetBytesCode"));

      assertEquals(menory2DBCode,WebPmConfig.getProperty("Encoder.Menory2DBCode"));
      assertEquals(menory2DBGetBytesCode,WebPmConfig.getProperty("Encoder.Menory2DBGetBytesCode"));

      assertEquals(urlParam2StringCode,WebPmConfig.getProperty("Encoder.URLParam2StringCode"));
      assertEquals(urlParam2StringGetBytesCode,WebPmConfig.getProperty("Encoder.URLParam2StringGetBytesCode"));

      assertEquals(string2URLParamCode,WebPmConfig.getProperty("Encoder.String2URLParamCode"));
      assertEquals(string2URLParamGetBytesCode,WebPmConfig.getProperty("Encoder.String2URLParamGetBytesCode"));

      assertEquals(DBUser,WebPmConfig.getProperty("DB.UserName"));
      assertEquals(DBPass,WebPmConfig.getProperty("DB.Password"));

      assertEquals(DBURL,WebPmConfig.getProperty("DB.URL"));
      assertEquals(DBDriver,WebPmConfig.getProperty("DB.Driver") );

      assertEquals(ArticleFactoryImp,WebPmConfig.getProperty("ArticleFactoryImp.className"));
      assertEquals(TagProcessorFactoryImp,WebPmConfig.getProperty("TagProcessorFactoryImp.className"));
  }
}