package org.softme.webpm.jwiki;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.softme.webpm.utility.XMLUtility;
import java.util.HashMap;
import org.softme.webpm.pub.Debug;
import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;
import org.softme.webpm.pub.WebPmConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class TagProcessorFactoryImp extends TagProcessorFactory{
    private static TagProcessorFactory tagFactoryInstance=null;
    //private static String CONFIG_FILE="/usr/tomcat/tomcat/webapps/webpm/tag.xml";
    //private static String CONFIG_FILE="c:\\config.xml";
    private HashMap processors=new HashMap();
    //private Iterator processorIterator=null;
    private ArrayList processList=new ArrayList();
    public TagProcessorFactoryImp() {
       // Debug.println("init TagProcessorFactoryImp") ;
        loadProcessors();
    }

    /*
    public  TagProcessorFactory getTagProcessorFactoryInstance(){
        if(tagFactoryInstance==null){
            Debug.println("Has getInstanece") ;

            tagFactoryInstance=new TagProcessorFactoryImp();

        }
        return tagFactoryInstance;
    }
    */
    public  String processTags(String pBody){
        /*
        while(processorIterator.hasNext()){
            TagProcessor processor=(TagProcessor)processorIterator.next() ;
            pBody=processor.process(pBody) ;
            Debug.println(processor.toString() +":"+pBody) ;
        }
        return pBody;
        */
        //Debug.println(processList.size() +"") ;
        for(int i=0;i<processList.size() ;i++){

            TagProcessor processor=(TagProcessor)processList.get(i);
            pBody=processor.process(pBody) ;
           // Debug.println(processor.toString()) ;
        }

        return pBody;
    }

    public  TagProcessor getProcessor(String pProcessorName){
         return (TagProcessor)processors.get(pProcessorName) ;
    }
   //  private void toIterator(){
       // Collection processorCollection=processors.values();

       // processorIterator=processorCollection.iterator() ;
 //   }

    private void loadProcessors(){
        Debug.println("Loading processors....") ;
        Document doc=XMLUtility.xml2Document(WebPmConfig.getProperty("Path.configfile")) ;
        NodeList nodelist=doc.getElementsByTagName("processor") ;
        for(int i=0;i<nodelist.getLength() ;i++){
            Node tagNode=(Node)nodelist.item(i) ;
            NamedNodeMap attrs=tagNode.getAttributes() ;
            Node classNode=attrs.getNamedItem("class") ;
            String className=classNode.getNodeValue();

            Node nameNode=attrs.getNamedItem("name") ;
            String tagName=nameNode.getNodeValue() ;
            Debug.println("load "+tagName+" "+className+".....") ;
            try{
                Class c=Class.forName(className) ;
                TagProcessor processor=(TagProcessor)c.newInstance() ;
                processors.put(tagName,processor); //
                processList.add(processor) ; //봦б
                Debug.println("OK") ;
            }catch(Exception e){
                Debug.println("FALSE") ;
                e.printStackTrace();
                Debug.println(e.toString() ) ;
            }
        }//

    }


}