package org.softme.webpm.jwiki;
import org.w3c.dom.*;
import org.softme.webpm.utility.XMLUtility;
import java.util.HashMap;
import org.softme.webpm.pub.Debug;
import java.util.ArrayList;
import org.softme.webpm.pub.WebPmConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class LinkProcessor implements TagProcessor{
   // private final String TAG_FILE="/usr/tomcat/tomcat/webapps/webpm/tag.xml";

    private ArrayList tags=new ArrayList();
    public LinkProcessor() {
        loadTag();
    }
    public String process(String pStr){
       for(int i=0;i<tags.size() ;i++){
           LinkTagInfo oneTag=(LinkTagInfo)tags.get(i);
           pStr=REReplace.replaceAutoLink(oneTag.linkcode,oneTag.foundcode,oneTag.notfoundcode,pStr) ;
       }
       return pStr;
    }
    private void loadTag(){
        Document doc=XMLUtility.xml2Document(WebPmConfig.getProperty("Path.tagfile")) ;
        NodeList wikiNodeList=doc.getElementsByTagName("link-tag") ;
        Element wikiElement=(Element)wikiNodeList.item(0) ;
        NodeList tagMaps=wikiElement.getElementsByTagName("map") ;
        LinkTagInfo oneTag=null;
        for(int i=0;i<tagMaps.getLength() ;i++){
            oneTag=new LinkTagInfo();
            NamedNodeMap attrs=(tagMaps.item(i)).getAttributes() ;
            oneTag.linkcode  =attrs.getNamedItem("link-code").getNodeValue() ;
            oneTag.foundcode  =attrs.getNamedItem("found-map-to").getNodeValue()  ;
            oneTag.notfoundcode =attrs.getNamedItem("notfound-map-to").getNodeValue()  ;
            tags.add(oneTag) ;
            Debug.println(oneTag.linkcode ) ;
        }
    }

public class LinkTagInfo {
    public String linkcode=null,foundcode=null,notfoundcode=null;
    public LinkTagInfo() {
    }
}
}