package org.softme.webpm.pub;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.DriverManager;
public class DBConnection {

    private DBConnection() {
    }
    /* õһݿ */
    public static Connection newInstance() throws java.sql.SQLException{
        try{
           // Debug.println( WebPmConfig.getProperty(WebPmConfig.DB_PASSWORD )) ;
            //Debug.println( WebPmConfig.getProperty(WebPmConfig.DB_USER  )) ;
            Class.forName(WebPmConfig.getProperty("DB.Driver")) ;
            Connection conn=DriverManager.getConnection(WebPmConfig.getProperty("DB.URL"),
                                                        WebPmConfig.getProperty("DB.UserName"),
                                                        WebPmConfig.getProperty("DB.Password")) ;

            return conn;
        }
        catch(java.lang.ClassNotFoundException ex){
            throw new java.sql.SQLException ("Can't get connection:"+ex.toString());
        }
        catch(java.sql.SQLException sqlex){
            throw sqlex;
        }

    }
  public static void closeConnection(PreparedStatement pstmt,Connection conn){
      try{pstmt.close() ;conn.close() ;}
      catch(SQLException e){Debug.println(e.toString());}
  }
}