package org.softme.webpm.pub;
import junit.framework.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WebPmConfigTest extends TestCase{

  public WebPmConfigTest(String name) {
      super(name);
  }
  public static void main(String[] args) {

      junit.textui.TestRunner.run(WebPmConfigTest.class) ;

  }
  public void testConfigParam(){
      final String StringChineseCode="ISO-8859-1";
      final String StringGetBytesCode="GB2312";
      final String DBChineseCode="GB2312";
      final String DBGetBytesCode="ISO-8859-1";
      final String DBUser="webpm";
      final String DBPass="webpm";
      final String DBURL="jdbc:mysql://192.168.1.228:3306/webpm";
      final String DBDriver="org.gjt.mm.mysql.Driver";
      final String ArticleFactoryImp="org.softme.webpm.jwiki.ArticleFactoryImp";
      final String TagProcessorFactoryImp="org.softme.webpm.jwiki.TagProcessorFactoryImp";




      assertEquals(StringChineseCode,WebPmConfig.getProperty("Encoder.StringCode") );
      assertEquals(StringGetBytesCode,WebPmConfig.getProperty("Encoder.StringGetBytes"));
      assertEquals(DBChineseCode,WebPmConfig.getProperty("Encoder.DBCode"));
      assertEquals(DBGetBytesCode,WebPmConfig.getProperty("Encoder.DBGetBytes"));
      assertEquals(DBUser,WebPmConfig.getProperty("DB.UserName"));
      assertEquals(DBPass,WebPmConfig.getProperty("DB.Password"));
      assertEquals(DBURL,WebPmConfig.getProperty("DB.URL"));
      assertEquals(DBDriver,WebPmConfig.getProperty("DB.Driver") );
      assertEquals(ArticleFactoryImp,WebPmConfig.getProperty("ArticleFactoryImp.className"));
      assertEquals(TagProcessorFactoryImp,WebPmConfig.getProperty("TagProcessorFactoryImp.className"));
  }
}