package org.softme.webpm.utility ;
import org.softme.webpm.pub.Debug;
import java.io.*;
import java.util.*;
import org.apache.regexp.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.softme.webpm.pub.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class StringUtility {



  private StringUtility() {
  }

  public static String encodeToMysql(String pString){
      //Debug.println("MYSqlEncoder==>DBGetBytes:"+WebPmConfig.getProperty("Encoder.DBGetBytes")+":"+WebPmConfig.getProperty("Encoder.DBCode")) ;
      return encode(pString,
                    WebPmConfig.getProperty("Encoder.DBGetBytes"),
                    WebPmConfig.getProperty("Encoder.DBCode"));

  }

  public static String URLParamEncode(String pString){
     // Debug.println("RULEncoder==>StringGetBytes:"+WebPmConfig.getProperty("Encoder.StringGetBytes")+":"+WebPmConfig.getProperty("Encoder.StringCode")) ;
      return encode(pString,
                    WebPmConfig.getProperty("Encoder.StringGetBytes"),
                    WebPmConfig.getProperty("Encoder.StringCode"));
  }
  private static String encode(String pString ,String pCode,String pGetBytesCode){
      String encodedString=pString;
      if(pCode.equalsIgnoreCase("")||pGetBytesCode.equalsIgnoreCase(""))  {
          Debug.println("StringUtility Waring:code or getbytescode is null") ;
          return pString;
      }
      try{

          encodedString=new String(pString.getBytes(pGetBytesCode),pCode);

      }catch(Exception e){
          Debug.println(e.toString() );
      }
      return encodedString;
  }

}