package org.softme.webpm.wiki;
import java.sql.*;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.utility.StringUtility;
import java.util.Vector;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class KeyIndex {
private static KeyIndex keyIndexInstance=null;
private Vector keyList=new Vector();
  private KeyIndex() {
      String GET_ALL_KEY="SELECT topic FROM article";
      Connection conn=null;
      PreparedStatement pstmt=null;
      String sTopic=null;
      try{
          Debug.print("KeyIndex init...") ;
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_ALL_KEY) ;
          ResultSet keyRs=pstmt.executeQuery() ;
          while(keyRs.next()){
              sTopic=keyRs.getString("topic");
              sTopic=StringUtility.URLParamEncode(sTopic);
              keyList.addElement(sTopic) ;

          }
          Debug.println("Succeed!") ;
      }catch(Exception e){
          Debug.println("False!") ;
          Debug.println(e.toString()) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }

  }
  public static KeyIndex getInstance(){
     if(keyIndexInstance==null){
          //Debug.print("KeyIndex init.....") ;
          keyIndexInstance=new KeyIndex();
         // Debug.println("succeed!") ;
          return keyIndexInstance;
      }else{
          return keyIndexInstance;
      }
  }

  public boolean isExist(String key){
      return keyList.contains(key);
  }
  public String addKey(String pKey){
      keyList.addElement(pKey) ;
      return pKey;
  }
}