package org.softme.webpm.utility ;
import org.softme.webpm.pub.Debug;
import java.io.*;
import java.util.*;
import org.apache.regexp.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.softme.webpm.pub.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class StringUtility {



  private StringUtility() {
  }

  public static String encodeDB2Menory(String pString){

      return encode(pString,
                    WebPmConfig.getProperty("Encoder.DB2MenoryGetBytesCode"),
                    WebPmConfig.getProperty("Encoder.DB2MenoryCode"));

  }
  public static String encodeMenory2DB(String pString){
      return encode(pString,
                    WebPmConfig.getProperty("Encoder.Menory2DBGetBytesCode"),
                    WebPmConfig.getProperty("Encoder.Menory2DBCode"));
  }

  public static String encodeString2URLParam(String pString){
     // return encode(pString,
      return encode(pString,
                    WebPmConfig.getProperty("Encoder.String2URLParamGetBytesCode"),
                    WebPmConfig.getProperty("Encoder.String2URLParamCode"));
  }
  public static String encodeURLParam2String(String pString){

      return encode(pString,
                    WebPmConfig.getProperty("Encoder.URLParam2StringGetBytesCode"),
                    WebPmConfig.getProperty("Encoder.URLParam2StringCode"));


  }

  private static String encode(String pString ,String pGetBytesCode,String pCode){
      String encodedString=pString;
      if(pString==null||pString.equals("")){
          return pString;
      }

      if(pCode.equalsIgnoreCase("")||pGetBytesCode.equalsIgnoreCase(""))  {
          return pString;
      }
      try{

          encodedString=new String(pString.getBytes(pGetBytesCode),pCode);

      }catch(Exception e){
          e.printStackTrace() ;
          Debug.println(e.toString() );
      }

      return encodedString;
  }

}